%ext ck4

#################
#Files		#
#################

%maphead maphead.ck4
%egahead EGAHEAD.CK4				#New graphics
%patchfile $20DF0 AUDIOHED.CK4			#Patch the Audiohead [652bytes]
%patchfile $249C2 KEEN4.tli			#New tile properties


#Level names
%patch $1F040 "Floor 00" $00
%patch $1F050 "Floor 01" $00
%patch $1F060 "Floor 02" $00
%patch $1F0B0 "Floor 03" $00
%patch $1F0C0 "Floor 04" $00
%patch $1F0D0 "Floor 05" $00


#################
#Enemies	#
#################

#Remove caches
%patch $EA74 $0000W
%patch $EDD1 $0000W
%patch $E9E4 $0000W

#Skypest anims
%patch $312F6 $0089W $0088W
%patch $3130A $09DC1752RL

#Skypest bounce off ground instead of landing
%patch $107B4 $C7 $44 $18 $FFF8W $C7 $44 $10 $FFFFW $EB $07

#Animations - 1 frame
%patch $31312 $2486W

#Mine anims
%patch $32700 $008AW $008AW
%patch $3271E $008AW $008AW
%patch $32728 $0001W
%patch $3273C $008BW $008BW
%patch $32746 $000AW

#Exploding mine makes boom like Keen
%patch $3272E $0B800BA9RL

#Member anims
%patch $30E28 $008CW $008DW
%patch $30E46 $008DW $008CW

#Council needs no standing
%patch $CD88 $EB

#Level Keen returns to on saving a Member (+1)
%patch $6AE9 $FF $06 $7A68W $90 $90

#Winning level goes to next level -max level is 4, stay there
%patch $6B1E $FF $06 $7A20W  $90 $90 $90
%patch $6B31 $83 $3E $7A20W  $04 $76 $04 $FF $0E $7A20W  $A1 $7A20W
                 $A3 $7A68W  $A1 $A7EDW  $A3 $A7C2W  $90

#Don't display Keen's reply boxes to the Gnostice Ancients
%patch $F549 $FF $06 $7A5EW  $9A $12A614EDRL     $9A $06BD2092RL     $B8 $0000W
             $50 $9A $1D06030DRL     $44 $44 $5D $CB

#Council member text
%patch $30C17 "Plot token" $0A
              "acquisition" $0A
              "successful." $0A
              "Proceeding to" $0A
              "next location." $00


#################
#Game		#
#################

#Don't ask before loading game during gameplay -Keen 4
%patch $1AFDA $EB $36

#MAKE GAME END AFTER LEVEL X\Y (Here demo and ending levs)
%patch $6B4B $A7EDW $04 $74 $A2 #If demlev
%patch $6B54 $11 $75

#Win the game instead of going to high scores
%patch $6B57 $EB $99

#Win game when getting member on level 4
%patch $6AE4  $A7EDW  $04 $74

#Force check to fix occasional game start in PC mode
%patch $1901D $EB $05
%patch $19024 $B8 $0001W  $90 $90 $90 $90 $90

#Replace pogo in config
%patch $336D2 "ZERO"
%patch $33BE0 "ZERO"

#Fix choppy scrolling -Keen 4
%patch $1E87A $E9 $FF7CW
%patch $1E7F9 $55 $8B $EC $BA $DA $03 $FA $EC $A8 $01 $74 $FB $EC $A8 $01 $75
              $FB $8B $4E $06 $BA $D4 $03 $B0 $0C $EE $42 $8A $C5 $EE $4A $B0
              $0D $EE $8A $C1 $42 $EE $C7 $06 $E6F4W  $0000W  $8B $16 $E6F4W
              $83 $FA $09 $73 $19 $FB $90 $90 $90 $90 $90 $90 $90 $90 $90 $FA
              $90 $90 $90 $90 $90 $90 $BA $DA $03 $EC $A8 $08 $74 $DE $BA $C0
              $03 $B0 $33 $EE $EB $00 $8A $46 $08 $EE $FB $5D $CB

#Keen Dreams style level loading box -Keen 4
%patch $38FF $EB $22

#Eliminate saved column, shrink HS
%patch $5A1F $0050W #Horizontal position of names column
%patch $5A9A $00F0W #Horizontal position of scores column

#Don't show Members saved in High Scores
%patch $5A36 $25

#Remove Huffman compression
%patch $12D2C $55 $8B $EC $56 $57 $8C $DA $C4 $7E $0A $C5 $76 $06 $8B $4E $0E $D1
              $E9 $FC $F3 $A5 $73 $01 $A4 $8E $DA $5F $5E  $5D $CB

#Disable status window -Keen 4
%patch $78B2 $EB $30

#Play music in the menu
%patch $1CC6F $06BD20C7RL
%patch $1CC6B $0005W      #Play this level's song

#Song list
%patch $2F206 $0003W  #Map                  (Shadowlands)          0
              $0003W  #Border Village       (Kick in the Pants)    1
              $0003W  #Slug Village         (Slug Village)         2
              $0003W  #Perilous Pit         (Slug Village)         3
              $0003W  #Cave of Descendants  (Too Hot)              4
              $0004W  #Chasm of Chills      (Too Hot)              5
              $0005W  #Crystalus            (Kick in the Pants)    6
              $0005W  #Hillville            (Slug Village)         7
              $0005W  #Sand Yego            (Eat your Veggies)     8
              $0005W  #Miragia              (Eat your Veggies)     9
              $0005W  #Lifewater Oasis      (Eat your Veggies)    10
              $0005W  #Pyramid of Moons     (Too Hot)             11
              $0000W  #Pyramid of Shadows   (Too Hot)             12
              $0005W  #Pyramid of Ancients  (Too Hot)             13
              $0005W  #Pyramid of Forbidden (Too Hot)             14
              $0005W  #Isle of Tar          (Too Hot)             15
              $0005W  #Isle of Fire         (Too Hot)             16
              $0005W  #Well of Wishes       (Eat your Veggies)    17
              $0005W  #Bwb Megarocket       (Slug Village)        18
              $0000W  #High scores          (No music, "Fanfare") 19

#No help options
%patch $9B69 $90 $90
%patch $99BA $C7 $06 $C8A3W  $0000W $EB $14
%patch $99EA $90 $90 $90 $90 $90

#Terminator sequence goes straight to title - Keen 4
%patch $50ED $A545W $001CW

#Star wars text appears before new game
%patch $5CB9 $9A $03ED18B8RL     $90

#Pressing any key in the story screen doesn't go to main menu
%patch $5894 $90 $90 $90 $90

#Remove Story screen from demo loop
%patch $3CBD $04D1W

#What level(s) Keen uses map tile interaction in -Keen 4
%patch $8FBC $A7EDW $08 $74

#Story text file
%patch $1EE40 "KEENBALL" $0A $0A

              "A remote and highly" $0A
              "radioactive faciity." $0A
              "A remote and remote" $0A
              "-controlled robot." $0A $0A

              "Interplanetary hero" $0A
              "COMMANDER KEEN" $0A
              "guides his newest" $0A
              "invention, the" $0A
              "sphere-o-droid," $0A
              "across a toxic," $0A
              "inhospitable" $0A
              "environment." $0A $0A

%patch $1EF1A "He must acquire" $0A
              "the incredibly" $0A
              "valuable giga-" $0A
              "positronum atoms" $0A
              "before the entire" $0A
              "reactor building" $0A
              "overloads and is" $0A
              "destroyed." $1A $00 $00 $00

#Levels F10 + W accesses -Keen 4
%patch $2F418 " Warp to which level(0-3):" $00
%patch $77E4 $03

#Pit tile (Replaces raindrop, needs time to active plummet)
%patch $D178 $FF $06 $00BEW  $83 $3E $00BEW  $20 $72  $0A $C7 $06 $00BCW  $0AD6W
                 $0E $E8 $FA5CW  $E9 $008EW
%patch $2EF2E $0000W

#Plummet sequence (Wheee!)
%patch $2F946 $0096W $0096W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0AF4W
%patch $2F964 $0097W $0097W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0B12W
%patch $2F982 $0098W $0098W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0B30W
%patch $2F9A0 $0099W $0099W $0000W $0000W $0000W $000DW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $0CF2W

#Keen entering levels
%patch $1F1F0 "Loading" $0A "Level One" $00
%patch $1F210 "Loading" $0A "Level Two" $00
%patch $1F240 "Loading" $0A "Level Three" $00
%patch $1F260 "Loading" $0A "Level Four" $00

#Scorebox displays level number
%patch $DB69 $A7EDW

#Don't need debug mode to use F10 cheats
%patch $7AB7 $90 $90

#Ending sequence doesn't have border images
%patch $9612 $0B $FF $74 $4D $B8 $0050W  $50 $33 $C0 $50 $50 $9A $1D060C79RL
                 $83 $C4 $06 $B8 $0051W  $50 $B8 $0008W  $50 $33 $C0 $50 $9A    
             $1D060C79RL     $83 $C4 $06 $B8 $0052W  $50 $B8 $0008W  $50 $B8
             $0138W  $50 $9A $1D060C79RL     $83 $C4 $06 $B8 $0053W  $50 $B8
             $00B0W  $50 $B8 $0008W  $50 $9A $1D060C79RL     $83 $C4 $06 $EB
             $14

#Disable all demos -Keen 4
%patch $33CD9 "TITLE SCREEN" $00
%patch $5901 $CB

#Skip initialization screen (Frees $19AAA-$19FE9)
%patch $38AD $90 $90 $90 $90 $90 #Don't load B800
%patch $38D0 $90 $90 $90 $90 $90 #Don't display game info, 'Loading...' text
%patch $39B2 $90 $90 $90 $90 $90 #Don't wait for key, show 'Ready' text


#################
#Keen		#
#################

#Standing behavior ignores tiles, behaves properly
%patch $2F800 $02
%patch $2F80A $00
%patch $2F814 $09DC176ERL

#New standing behavior: Overrides bored and allows trajectory setting
%patch $BB95 $55 $8B $EC $56 $8B $76 $06 $83 $3E $A7D2W  $04 $75 $0C $81 $3E #^ inc vel limit $7F
             $7A58W  $007FW  $73 $04 $FF $06 $7A58W  $83 $3E $A7D2W  $00 $75 #v dec vel limit $81
             $0C $81 $3E $7A58W  $FF81W  $7E $04 $FF $0E $7A58W  $83 $3E
         $A7D2W  $02 $75 $0C $81 $3E $7A5CW  $007FW  $73 $04 $FF $06 $7A5CW  #> inc vel limit $7F
             $83 $3E $A7D2W  $06 $75 $0C $81 $3E $7A5CW  $FF81W  $7E $04 $FF #< dec vel limit $81
             $0E $7A5CW  $83 $3E $C5C5W  $00 $74 $08 $33 $C0 $A3 $7A58W  $A3 #Alt set 0
             $7A5CW

#Adjust g-input to be jump only -uses base settings for HV
%patch $BBF7 $83 $3E $C5C9W  $00 $74 $76 $83 $3E $C5C7W  $00 $75 $6F $C7 $06 #Jump
             $C5C7W  $0001W  $B8 $002BW  $50 $9A $187409F1RL     $83 $C4 $02
             $83 $3E $7A58W  $10 $7D $1B $83 $3E $7A58W  $F0 $7E $14 $83 $3E
             $7A5CW  $10 $7D $0D $83 $3E $7A5CW  $F0 $7E $06 $81 $36 $7A58W
             $0010W  

             $A1 $7A5CW  $A3 $09B6W  $A1 $7A58W  $A3 $09B8W  $C7 $06 $C921W
             $0000W  $C7 $06 $CABBW  $0012W  $C7 $44 $1C $09AAW  $8B $1E $A7D6W
                 $8B $7F $48 $EB $11 $83 $3D $1F $75 $09 $57 $9A $06BD1E8BRL
                 $83 $C4 $02 $8B $7D $48 $0B $FF $75 $EB $5E $5D $CB

#Adjust g-input to be jump only -uses base settings for HV
%patch $BBF7 $83 $3E $C5C9W  $00 $75 $03 $E9 $0088W $83 $3E $C5C7W  $00 $74  #Jump
             $03 $E9 $007EW  $C7 $06
             $C5C7W  $0001W  $B8 $002BW  $50 $9A $187409F1RL     $83 $C4 $02
             $83 $3E $7A58W  $10 $7D $2A $83 $3E $7A58W  $F0 $7E $23 $83 $3E
             $7A5CW  $10 $7D $1C $83 $3E $7A5CW  $F0 $7E $15 $83 $3E $7A5CW
             $00 $74 $08 $81 $36 $7A5CW  $0010W  $EB $06 $81 $36 $7A58W  $0010W  
             
             $A1 $7A5CW  $A3 $09B6W  $A1 $7A58W  $A3 $09B8W  $C7 $06 $C921W
             $0000W  $C7 $06 $CABBW  $0012W  $C7 $44 $1C $09AAW  $8B $1E $A7D6W
                 $8B $7F $48 $EB $11 $83 $3D $1F $75 $09 $57 $9A $06BD1E8BRL
                 $83 $C4 $02 $8B $7D $48 $0B $FF $75 $EB $5E $5D $CB

#Keenball moving action -shotlike (Sp 9B6, 9B8)
%patch $2F81A $0092W $0092W $0004W $0000W $0000W $0004W $0040W $0040W
              $0B800265RL   $0B8014A9RL   $0B801B5FRL   $09AAW

#Behavior: friction, revert at v=0 =$0B800265RL
%patch $BA65 $55 $8B $EC $56 $8B $76 $06 $81 $3E $09B6W  $0000W  $7C $08 $74
             $0A $FF $0E $09B6W  $EB $04 $FF $06 $09B6W  $81 $3E $09B8W  $0000W
                 $7C $08 $74 $0A $FF $0E $09B8W  $EB $04 $FF $06 $09B8W  $81
             $3E $09B6W  $0000W  $75 $17 $81 $3E $09B8W  $0000W  $75 $0F $C7
             $44 $1C $09C8W  $C7 $44 $0E $0001W  $C7 $44 $10 $0001W
$5E $5D $CB

#Tile collision; if touching sides, bounce
%patch $D35F $55 $8B $EC $56 $8B $76 $06 $83 $7C $36 $01 $74 $06 $83 $7C $3A #Floor, ceiling
             $01 $75 $08 $81 $36 $09B8W  $FFFFW  $EB $48 $83 $7C $38 $01 $74
             $06 $83 $7C $3C $01 $75 $08 $81 $36 $09B6W  $FFFFW  $EB $34 $83 #Right, left walls
             $7C $36 $05 $7C $3C $81 $3E $09B6W  $0000W  $7C $14 $81 $3E     #Down->up sloes
         $09BBW  $0000W  $7C $0C $81 $36 $09B8W  $FFFFW  $81 $36 $09B6W
         $FFFFW  $A1 $09B6W  $A3 $00BEW  $A1 $09B8W  $A3 $09B6W  $A1 $00BEW
             $A3 $09B8W  $B8 $000FW  $50 $9A $187409F1RL     $83 $C4 $02 $EB
             $48 $83 $7C $36 $01 $7C $12 $81 $3E $09B6W  $0000W  $7D $D2 $81 #Up->down slopes
             $3E $09B8W  $0000W  $7E $CA $EB $BC $83 $7C $3A $05 $7C $12 $81
             $3E $09B6W  $0000W  $7E $BA $81 $3E $09B8W  $0000W  $7E $B2 $EB #Up->down ceilings
             $A4 $83 $7C $3A $01 $7C $12 $81 $3E $09B6W  $0000W  $7F $A2 $81 #Down->up ceilings
             $3E $09B8W  $0000W  $7F $9A $EB $8C $FF $74 $20 $33 $C0 $50 $FF
             $74 $1E $FF $74 $0C $FF $74 $0A $8B $C6 $05 $46 $00 $50 $9A
         $16541641RL     $83 $C4 $0C $5E $5D $CB

#Keen target spawning action =$09C8W
%patch $2F838 $0094W $0094W $0000W $0000W $0000W $0004W $0000W $0000W
              $0B800B5BRL   $0B8014A9RL   $09DC176ERL   $098CW

#Spawn target at level start
%patch $B844 $09C8W

#Keen sit produces satellite pointer each time =$0B800B5BRL
%patch $C35B $55 $8B $EC $56 $8B $76 $06 $B8 $0001W  $50 $9A $06BD1E11RL
             $83 $C4 $02 $8B $44 $0A $8B $1E $D8 $A7 $89 $47 $0A $8B $44 $0C
             $05 $0080W  $89 $47 $0C $C7 $47 $06 $0000W  $C7 $07 $001FW  $C7
             $47 $20 $0003W  $C7 $47 $0E $0001W  $C7 $47 $10 $0001W  $B8 $09E6W 
                 $50 $53 $9A $09DC118CRL     $83 $C4 $04 $5E $5D $CB

#Pointer actions: init, mov, sit
%patch $2F856 $FFFFW $FFFFW $0000W $0000W $0000W $0001W $0000W $0000W
              $0D8F06F0RL   $00000000L    $09DC176ERL   $0A22W
%patch $2F892 $0000W $0000W $0001W $0000W $0000W $000EW $0040W $0040W
              $00000000L    $00000000L    $09DC176ERL   $0A40W
%patch $2F8B0 $0095W $0095W $0000W $0000W $0000W $000FW $0000W $0000W
              $00000000L    $00000000L    $09DC176ERL   $09E6W

#Pointer aims properly around Keen =$0D8F06F0RL
%patch $DFE0 $55 $8B $EC $56 $8B $76 $06 $A1 $1427W  $89 $44 $0A $A1 $142AW
             $89 $44 $0C $A1 $7A5CW  $A3 $0A2EW  $A1 $7A58W  $A3 $0A30W
             $5E $5D $CB

#Keen stores position for pointer orientation
%patch $D0F4 $8B $44 $0A $A3 $1427W  $8B $44 $0C $A3 $142AW  $90

#Redo death code to produce 1 action, no death cycle traps
%patch $CBE9  $55 $8B $EC $83 $3E $C5D1W  $00 $74 $03 $E9 $FFF1W  $83 $3E $C629W #Check for godmode, Plp timer
                  $00 $74 $03 $E9 $FFE7W  $8B $1E $A7D6W  $81 $7F $1C $0CD4W
              $75 $03 $E9 $FFD9W  $C7 $06 $CAB5W  $0000W  $C7 $06 $C5D1W  $001EW #Set mooning = 0, Plp = 1E
                  $C7 $06 $A7DAW $0001W  $C7 $47 $06 $0000W  $C7 $47 $20 $0002W #Set scrl, fore = 3, clip = 0
              $A1 $00BCW  $50 $FF $36 $D6 $A7 $9A $09DC120ARL     $83            #Turn Keen into dead 1
              $C4 $04 $B8 $0017W  $50 $9A $187409F1RL     $83 $C4 $02            #Play sound 17
              $33 $C0 $A3 $7A58W  $A3 $7A5CW  $8B $1E $A7D6W  $C7 $06		 #Set godmode to avoid bleh
              $C629W  $0001W  $5D $CB

#On level reload turn of godmode, reset death action, plummet timer
%patch $69E3 $C7 $06 $00BCW  $0CF2W  $C7 $06 $C629W  $0000W
             $C7 $06 $00BEW $0000W  $EB $3C

#Death variable set as regular death
%patch $2EF2C $0CF2W

#Death sequence: Explode, vanish, lose level (Spawn boom, sit, invis)
%patch $2FB62 $00A2W $00A2W $0000W $0000W $0000W $0001W $0000W $0000W #Spawn boom
              $0B800BA9RL   $00000000L    $09DC176ERL   $0D10W
%patch $2FB80 $00A2W $00A2W $0000W $0000W $0000W $000EW $0000W $0000W #Sit
              $00000000L    $00000000L    $09DC176ERL   $36CEW

#Make explosion behavior =$0B800BA9RL
%patch $C3A9 $55 $8B $EC $56 $8B $76 $06 $B8 $0001W  $50 $9A $06BD1E11RL
             $83 $C4 $02 $8B $44 $0A $8B $1E $D8 $A7 $89 $47 $0A $8B $44 $0C
             $05 $0000W  $89 $47 $0C $C7 $47 $06 $0000W  $C7 $07 $001FW  $C7
             $47 $20 $0003W  $C7 $47 $1E $0083W  $8B $44 $0E $8B $1E $D8 $A7
             $89 $47 $0E $B8 $0A04W  $50 $53 $9A $09DC118CRL     $83 $C4 $04
             $5E $5D $CB

#Explosion sequence (Mines and dead Keen) =$0A04W
%patch $2F874 $0000W $0000W $0000W $0000W $0000W $0008W $0000W $0000W
              $0B800BFCRL   $00000000L    $09DC176ERL   $0A04W

#Explosion behavior (Cycle animation, vanish) =$0B800BFCRL
%patch $C3FC $55 $8B $EC $56 $8B $76 $06 $FF $44 $1E $8B $44 $1E $3D $0087W
             $76 $05 $C7 $44 $1C $0000W  $5E $5D $CB

%end